diff -ruN gcc-15.1.0.orig/libgcc/config/rs6000/gthr-morphos.h gcc-15.1.0/libgcc/config/rs6000/gthr-morphos.h
--- gcc-15.1.0.orig/libgcc/config/rs6000/gthr-morphos.h	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/libgcc/config/rs6000/gthr-morphos.h	2025-04-25 15:58:40.280619963 +0300
@@ -0,0 +1,433 @@
+/* Threads compatibility routines for libgcc2.  */
+/* Compile this one with gcc.  */
+/* Copyright (C) 1997, 1999, 2000, 2004, 2008, 2009
+   Free Software Foundation, Inc.
+   Copyright (C) 2016-2020 Harry Sintonen
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 3, or (at your option) any later
+version.
+
+GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+Under Section 7 of GPL version 3, you are granted additional
+permissions described in the GCC Runtime Library Exception, version
+3.1, as published by the Free Software Foundation.
+
+You should have received a copy of the GNU General Public License and
+a copy of the GCC Runtime Library Exception along with this program;
+see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+<http://www.gnu.org/licenses/>.  */
+
+#ifndef GCC_GTHR_MORPHOS_H
+#define GCC_GTHR_MORPHOS_H
+
+#define __GTHREADS 1
+#define __GTHREADS_CXX0X 1
+#define __GTHREAD_HAS_COND 1
+
+#include <sys/time.h>
+#include <errno.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+ * __gthr_morphos_active_p
+ */
+
+extern int __gthr_morphos_active_p (void);
+static int __is_gthr_morphos_active = -1;
+
+static inline int
+__gthread_active_p (void)
+{
+  if(__is_gthr_morphos_active < 0)
+    __is_gthr_morphos_active = __gthr_morphos_active_p();
+
+  return __is_gthr_morphos_active > 0 ? 1 : 0;
+}
+
+/*
+ * MorphOS - Generic
+ */
+
+typedef struct timespec __gthread_time_t;
+#define __GTHREAD_TIME_INIT { 0, 0 }
+
+/*
+ * MorphOS - Once
+ */
+
+#define __GTHREAD_ONCE_INIT { 0, 0 }
+
+typedef struct {
+	volatile long busy;
+	volatile long done;
+} __gthread_once_t;
+
+extern int __gthr_morphos_once (__gthread_once_t *__once, void (*__func) (void));
+extern void __gthr_morphos_once_unlock (__gthread_once_t *__once);
+
+/*
+ * MorphOS - Key
+ */
+
+typedef unsigned long __gthread_key_t;
+
+extern int __gthr_morphos_key_create (__gthread_key_t *__key, void (*__func) (void *));
+extern int __gthr_morphos_key_delete (__gthread_key_t __key);
+extern void *__gthr_morphos_getspecific (__gthread_key_t __key);
+extern int __gthr_morphos_setspecific (__gthread_key_t __key, const void *__v);
+
+/*
+ * MorphOS - Mutex
+ */
+
+#define __GTHREAD_MUTEX_INIT_FUNCTION           __gthread_mutex_init_function
+#define __GTHREAD_MUTEX_INIT                    { {{ 0 }}, 0 }
+#ifdef _GTHREAD_USE_MUTEX_INIT_FUNC
+# undef __GTHREAD_MUTEX_INIT
+#endif
+#define __GTHREAD_RECURSIVE_MUTEX_INIT_FUNCTION __gthread_recursive_mutex_init_function
+#define __GTHREAD_RECURSIVE_MUTEX_INIT          { {{ 0 }}, 0 }
+#ifdef _GTHREAD_USE_RECURSIVE_MUTEX_INIT_FUNC
+# undef __GTHREAD_RECURSIVE_MUTEX_INIT
+#endif
+
+typedef struct {
+	union {
+		char _priv[60];
+	} u;
+	int incond;
+} __gthread_mutex_t;
+
+typedef __gthread_mutex_t __gthread_recursive_mutex_t;
+
+extern void __gthr_morphos_mutex_init_function (__gthread_mutex_t *__mutex);
+extern int __gthr_morphos_mutex_destroy (__gthread_mutex_t *__mutex);
+
+extern int __gthr_morphos_mutex_lock (__gthread_mutex_t *__mutex);
+extern int __gthr_morphos_mutex_trylock (__gthread_mutex_t *__mutex);
+extern int __gthr_morphos_mutex_unlock (__gthread_mutex_t *__mutex);
+extern int __gthr_morphos_mutex_timedlock (__gthread_mutex_t *__mutex,
+                                           const __gthread_time_t *__abs_timeout);
+
+extern void __gthr_morphos_recursive_mutex_init_function (__gthread_recursive_mutex_t *__mutex);
+extern int __gthr_morphos_recursive_mutex_lock (__gthread_recursive_mutex_t *__mutex);
+extern int __gthr_morphos_recursive_mutex_trylock (__gthread_recursive_mutex_t *__mutex);
+extern int __gthr_morphos_recursive_mutex_unlock (__gthread_recursive_mutex_t *__mutex);
+extern int __gthr_morphos_recursive_mutex_destroy (__gthread_mutex_t *__mutex);
+extern int __gthr_morphos_recursive_mutex_timedlock (__gthread_mutex_t *__mutex,
+                                                     const __gthread_time_t *__abs_timeout);
+
+/*
+ * MorphOS - Cond
+ */
+
+#define __GTHREAD_COND_INIT          { {{ 0 }}, {{ 0 }} }
+#ifdef _GTHREAD_USE_COND_INIT_FUNC
+# undef __GTHREAD_COND_INIT
+# define __GTHREAD_COND_INIT_FUNCTION __gthread_cond_init_function
+#endif
+
+typedef struct {
+	union {
+		char _priv[60];
+	} u1;
+	union {
+		void *_priv[3];
+	} u2;
+} __gthread_cond_t;
+
+extern void __gthr_morphos_cond_init_function (__gthread_cond_t *__cond);
+extern int __gthr_morphos_cond_destroy (__gthread_cond_t *__cond);
+extern int __gthr_morphos_cond_broadcast (__gthread_cond_t *__cond);
+extern int __gthr_morphos_cond_signal (__gthread_cond_t *__cond);
+extern int __gthr_morphos_cond_wait (__gthread_cond_t *__cond, __gthread_mutex_t *__mutex);
+extern int __gthr_morphos_cond_wait_recursive (__gthread_cond_t *__cond,
+                                               __gthread_recursive_mutex_t *__mutex);
+extern int __gthr_morphos_cond_timedwait (__gthread_cond_t *__cond,
+                                          __gthread_mutex_t *__mutex,
+                                          const __gthread_time_t *__abs_timeout);
+
+/*
+ * MorphOS - Thread
+ */
+
+typedef unsigned int __gthread_t;
+
+extern int __gthr_morphos_create (__gthread_t *__threadid, void *(*__func) (void *),
+                                  void *__args);
+extern int __gthr_morphos_join (__gthread_t __threadid, void **__value_ptr);
+extern int __gthr_morphos_detach (__gthread_t __threadid);
+extern int __gthr_morphos_equal (__gthread_t __t1, __gthread_t __t2);
+extern __gthread_t __gthr_morphos_self (void);
+extern int __gthr_morphos_yield (void);
+
+
+/*
+ * MorphOS - Once
+ */
+
+static inline int
+__gthread_once (__gthread_once_t *__once, void (*__func) (void))
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_once (__once, __func);
+  else
+    return -1;
+}
+
+static inline void
+__gthread_once_unlock (__gthread_once_t *__once)
+{
+  __gthr_morphos_once_unlock (__once);
+}
+
+/*
+ * MorphOS - Key
+ */
+
+static inline int
+__gthread_key_create (__gthread_key_t *__key, void (*__dtor) (void *))
+{
+  return __gthr_morphos_key_create (__key, __dtor);
+}
+
+static inline int
+__gthread_key_delete (__gthread_key_t __key)
+{
+  return __gthr_morphos_key_delete (__key);
+}
+
+static inline void *
+__gthread_getspecific (__gthread_key_t __key)
+{
+  return __gthr_morphos_getspecific (__key);
+}
+
+static inline int
+__gthread_setspecific (__gthread_key_t __key, const void *__ptr)
+{
+  return __gthr_morphos_setspecific (__key, __ptr);
+}
+
+/*
+ * MorphOS - Mutex
+ */
+
+static inline void
+__gthread_mutex_init_function (__gthread_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    __gthr_morphos_mutex_init_function (__mutex);
+}
+
+static inline int
+__gthread_mutex_destroy (__gthread_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_mutex_destroy (__mutex);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_mutex_lock (__gthread_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_mutex_lock (__mutex);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_mutex_trylock (__gthread_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_mutex_trylock (__mutex);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_mutex_timedlock (__gthread_mutex_t *__mutex,
+                           const __gthread_time_t *__abs_timeout)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_mutex_timedlock (__mutex, __abs_timeout);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_mutex_unlock (__gthread_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_mutex_unlock (__mutex);
+  else
+    return 0;
+}
+
+static inline void
+__gthread_recursive_mutex_init_function (__gthread_recursive_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    __gthr_morphos_recursive_mutex_init_function (__mutex);
+}
+
+static inline int
+__gthread_recursive_mutex_lock (__gthread_recursive_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_recursive_mutex_lock (__mutex);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_recursive_mutex_trylock (__gthread_recursive_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_recursive_mutex_trylock (__mutex);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_recursive_mutex_timedlock (__gthread_recursive_mutex_t *__mutex,
+                                     const __gthread_time_t *__abs_timeout)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_recursive_mutex_timedlock (__mutex, __abs_timeout);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_recursive_mutex_unlock (__gthread_recursive_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_recursive_mutex_unlock (__mutex);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_recursive_mutex_destroy (__gthread_mutex_t *__mutex)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_mutex_destroy (__mutex);
+  else
+    return 0;
+}
+
+/*
+ * MorphOS - Cond
+ */
+
+static inline void
+__gtrhread_cond_init_function (__gthread_cond_t *__cond)
+{
+  if (__gthread_active_p ())
+    __gthr_morphos_cond_init_function (__cond);
+}
+
+static inline int
+__gthread_cond_destroy (__gthread_cond_t *__cond)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_cond_destroy (__cond);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_cond_broadcast (__gthread_cond_t *__cond)
+{
+  return __gthr_morphos_cond_broadcast (__cond);
+}
+
+static inline int
+__gthread_cond_signal (__gthread_cond_t *__cond)
+{
+  return __gthr_morphos_cond_signal (__cond);
+}
+
+static inline int
+__gthread_cond_wait (__gthread_cond_t *__cond, __gthread_mutex_t *__mutex)
+{
+  return __gthr_morphos_cond_wait (__cond, __mutex);
+}
+
+static inline int
+__gthread_cond_wait_recursive (__gthread_cond_t *__cond,
+                               __gthread_recursive_mutex_t *__mutex)
+{
+  return __gthr_morphos_cond_wait_recursive (__cond, __mutex);
+}
+
+static inline int
+__gthread_cond_timedwait (__gthread_cond_t *__cond, __gthread_mutex_t *__mutex,
+                          const __gthread_time_t *__abs_timeout)
+{
+  return __gthr_morphos_cond_timedwait (__cond, __mutex, __abs_timeout);
+}
+
+/*
+ * MorphOS - Thread
+ */
+
+static inline int
+__gthread_create (__gthread_t *__threadid, void *(*__func) (void *),
+                  void *__args)
+{
+  if (__gthread_active_p ())
+    return __gthr_morphos_create (__threadid, __func, __args);
+  else
+    return 0;
+}
+
+static inline int
+__gthread_join (__gthread_t __threadid, void **__value_ptr)
+{
+  return __gthr_morphos_join (__threadid, __value_ptr);
+}
+
+static inline int
+__gthread_detach (__gthread_t __threadid)
+{
+  return __gthr_morphos_detach (__threadid);
+}
+
+static inline int
+__gthread_equal (__gthread_t __t1, __gthread_t __t2)
+{
+  return __gthr_morphos_equal (__t1, __t2);
+}
+
+static inline __gthread_t
+__gthread_self (void)
+{
+  return __gthr_morphos_self ();
+}
+
+static inline int
+__gthread_yield (void)
+{
+  return __gthr_morphos_yield ();
+}
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* ! GCC_GTHR_MORPHOS_H */
diff -ruN gcc-15.1.0.orig/libgcc/config/rs6000/t-gthr-morphos gcc-15.1.0/libgcc/config/rs6000/t-gthr-morphos
--- gcc-15.1.0.orig/libgcc/config/rs6000/t-gthr-morphos	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/libgcc/config/rs6000/t-gthr-morphos	2025-04-25 15:58:40.280619963 +0300
@@ -0,0 +1 @@
+LIB2ADD = $(srcdir)/config/rs6000/gthr-morphos.c
\ No newline at end of file
diff -ruN gcc-15.1.0.orig/libgcc/config.host gcc-15.1.0/libgcc/config.host
--- gcc-15.1.0.orig/libgcc/config.host	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libgcc/config.host	2025-04-25 15:58:40.280619963 +0300
@@ -1239,6 +1239,10 @@
 	  ;;
 	esac
 	;;
+powerpc-*-morphos*)
+	tmake_file="${tmake_file} rs6000/t-ppccomm rs6000/t-savresfgpr rs6000/t-crtstuff t-crtstuff-pic t-fdpbit rs6000/t-gthr-morphos"
+	extra_parts="$extra_parts crtbegin.o crtend.o crtbeginS.o crtendS.o crtbeginT.o ecrti.o ecrtn.o ncrti.o ncrtn.o"
+	;;
 powerpc-*-netbsd*)
 	tmake_file="$tmake_file rs6000/t-netbsd rs6000/t-crtstuff"
 	;;
diff -ruN gcc-15.1.0.orig/libgcc/crtstuff.c gcc-15.1.0/libgcc/crtstuff.c
--- gcc-15.1.0.orig/libgcc/crtstuff.c	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libgcc/crtstuff.c	2025-04-25 15:58:40.280619963 +0300
@@ -157,6 +157,10 @@
 # define USE_TM_CLONE_REGISTRY 0
 #endif
 
+#ifdef __MORPHOS__
+extern const char __EH_FRAME_BEGIN__[];
+#endif
+
 /* We do not want to add the weak attribute to the declarations of these
    routines in unwind-dw2-fde.h because that will cause the definition of
    these symbols to be weak as well.
@@ -397,7 +401,7 @@
   {
     /* Safer version that makes sure only .dtors function pointers are
        called even if the static variable is maliciously changed.  */
-    extern func_ptr __DTOR_END__[] __attribute__((visibility ("hidden")));
+    extern const func_ptr __DTOR_END__[] __attribute__((visibility ("hidden")));
     static size_t dtor_idx;
     const size_t max_idx = __DTOR_END__ - __DTOR_LIST__ - 1;
     func_ptr *dtor_list;
@@ -435,6 +439,11 @@
 #endif
 #endif
 
+#ifdef __MORPHOS__
+  if (__deregister_frame_info)
+    __deregister_frame_info (__EH_FRAME_BEGIN__);
+#endif
+
   completed = 1;
 }
 
@@ -692,9 +701,24 @@
 static void __attribute__((used))
 __do_global_ctors_aux (void)
 {
+#ifdef __MORPHOS__
+  if (__register_frame_info)
+  {
+    static struct object object;
+    __register_frame_info (__EH_FRAME_BEGIN__, &object);
+  }
+  func_ptr *p = __CTOR_END__ - 1;
+  func_ptr f;
+  while((f = *p) != (func_ptr) -1)
+  {
+    f ();
+    p--;
+  }
+#else
   func_ptr *p;
   for (p = __CTOR_END__ - 1; *p != (func_ptr) -1; p--)
     (*p) ();
+#endif
 }
 
 /* Stick a call to __do_global_ctors_aux into the .init section.  */
diff -ruN gcc-15.1.0.orig/libgcc/emutls.c gcc-15.1.0/libgcc/emutls.c
--- gcc-15.1.0.orig/libgcc/emutls.c	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libgcc/emutls.c	2025-04-25 15:58:40.280619963 +0300
@@ -95,6 +95,28 @@
   free (ptr);
 }
 
+#ifdef __libnix
+#include <constructor.h>
+DESTRUCTOR_P(emutls_cleanup, 10000)
+#else
+__attribute__((destructor))
+static void
+emutls_cleanup (void)
+#endif
+{
+  if (emutls_key)
+    {
+      struct __emutls_array *arr = __gthread_getspecific (emutls_key);
+      if (arr)
+	{
+	    __gthread_setspecific (emutls_key, NULL);
+	    emutls_destroy (arr);
+	}
+      __gthread_key_delete (emutls_key);
+      emutls_key = 0;
+    }
+}
+
 static void
 emutls_init (void)
 {
diff -ruN gcc-15.1.0.orig/libgcc/libgcov.h gcc-15.1.0/libgcc/libgcov.h
--- gcc-15.1.0.orig/libgcc/libgcov.h	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libgcc/libgcov.h	2025-04-25 15:58:40.280619963 +0300
@@ -49,6 +49,10 @@
 #include <sys/mman.h>
 #endif
 
+#ifndef _STDINT_H_
+#include <stdint.h>
+#endif
+
 #if __CHAR_BIT__ == 8
 typedef unsigned gcov_unsigned_t __attribute__ ((mode (SI)));
 typedef unsigned gcov_position_t __attribute__ ((mode (SI)));
diff -ruN gcc-15.1.0.orig/libiberty/stack-limit.c gcc-15.1.0/libiberty/stack-limit.c
--- gcc-15.1.0.orig/libiberty/stack-limit.c	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libiberty/stack-limit.c	2025-04-25 15:58:40.284619995 +0300
@@ -39,7 +39,7 @@
 #ifdef HAVE_STDINT_H
 #include <stdint.h>
 #endif
-#ifdef HAVE_SYS_RESOURCE_H
+#if defined(HAVE_SYS_RESOURCE_H) && !defined(__MORPHOS__)
 #include <sys/resource.h>
 #endif
 
diff -ruN gcc-15.1.0.orig/libobjc/objc/objc.h gcc-15.1.0/libobjc/objc/objc.h
--- gcc-15.1.0.orig/libobjc/objc/objc.h	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libobjc/objc/objc.h	2025-04-25 15:58:40.284619995 +0300
@@ -51,8 +51,13 @@
 
    Important: this could change and we could switch to 'typedef bool
    BOOL' in the future.  Do not depend on the type of BOOL.  */
+
+#ifdef __MORPHOS__
+#include <exec/types.h>
+#else
 #undef BOOL
 typedef unsigned char  BOOL;
+#endif
 
 #define YES   (BOOL)1
 #define NO    (BOOL)0
diff -ruN gcc-15.1.0.orig/libobjc/objc-sync.c gcc-15.1.0/libobjc/objc-sync.c
--- gcc-15.1.0.orig/libobjc/objc-sync.c	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libobjc/objc-sync.c	2025-04-25 15:58:40.284619995 +0300
@@ -174,6 +174,7 @@
 void
 __objc_sync_init (void)
 {
+#ifndef __MORPHOS__
   int i;
 
   for (i = 0; i < SYNC_NUMBER_OF_POOLS; i++)
@@ -193,8 +194,10 @@
 
       sync_pool_array[i] = new_node;
     }
+#endif
 }  
 
+#ifndef __MORPHOS__
 int
 objc_sync_enter (id object)
 {
@@ -457,3 +460,5 @@
   /* A lock for 'object' to unlock could not be found (!!).  */
   return OBJC_SYNC_NOT_OWNING_THREAD_ERROR;
 }
+
+#endif /* MorphOS */
diff -ruN gcc-15.1.0.orig/libobjc/objects.c gcc-15.1.0/libobjc/objects.c
--- gcc-15.1.0.orig/libobjc/objects.c	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libobjc/objects.c	2025-04-25 15:58:40.284619995 +0300
@@ -36,6 +36,7 @@
 #endif
 
 /* FIXME: The semantics of extraBytes are not really clear.  */
+#ifndef __MORPHOS__
 inline
 id
 class_createInstance (Class class, size_t extraBytes)
@@ -93,6 +94,7 @@
     }
   return nil;
 }
+#endif
 
 const char *
 object_getClassName (id object)
diff -ruN gcc-15.1.0.orig/libobjc/thr.c gcc-15.1.0/libobjc/thr.c
--- gcc-15.1.0.orig/libobjc/thr.c	2025-04-25 11:18:04.000000000 +0300
+++ gcc-15.1.0/libobjc/thr.c	2025-04-25 15:58:40.288620027 +0300
@@ -35,7 +35,16 @@
 #include "objc/runtime.h"
 #include "objc-private/module-abi-8.h"
 #include "objc-private/runtime.h"
+
+#ifdef __MORPHOS__
+// MorphOS specific includes
+#define __IXEMUL_EXEC_MIXING_ALLOWED /* FIXME: this code is really broken for ixemul */
+#include <proto/dos.h>
+#include <proto/exec.h>
+#include <dos/dostags.h>
+#else
 #include <gthr.h>
+#endif
 
 #include <stdlib.h>
 
@@ -75,7 +84,11 @@
 int
 __objc_init_thread_system(void)
 {
+#ifdef __MORPHOS__
+  return 0;
+#else
   return __gthread_objc_init_thread_system ();
+#endif
 }
 
 /* First function called in a thread, starts everything else.
@@ -165,6 +178,28 @@
   /* Lock access.  */
   objc_mutex_lock (__objc_runtime_mutex);
 
+#ifdef __MORPHOS__
+	ULONG pid = 0;
+	
+	struct Task *t = (struct Task *)CreateNewProcTags(
+		NP_PPC_Arg1, (IPTR)istate,
+		NP_Entry, (IPTR)__objc_thread_detach_function,
+		NP_CodeType, CODETYPE_PPC,
+		NP_Name, (IPTR)"ObjC Runtime",
+		TAG_DONE);
+
+	if (NULL != t)
+	{
+		NewGetTaskAttrsA(t, &pid, sizeof (pid), TASKINFOTYPE_PID, NULL);
+		thread_id = (objc_thread_t)pid;
+	}
+	else
+	{
+      objc_mutex_unlock (__objc_runtime_mutex);
+      objc_free (istate);
+      return NULL;
+	}
+#else
   /* Call the backend to spawn the thread.  */
   if ((thread_id = __gthread_objc_thread_detach ((void *)__objc_thread_detach_function,
 						 istate)) == NULL)
@@ -174,6 +209,7 @@
       objc_free (istate);
       return NULL;
     }
+#endif
 
   /* Increment our thread counter.  */
   __objc_runtime_threads_alive++;
@@ -186,14 +222,42 @@
 int
 objc_thread_set_priority (int priority)
 {
-  return __gthread_objc_thread_set_priority (priority);
+  int sys_priority = 0;
+
+  switch (priority)
+    {
+    case OBJC_THREAD_INTERACTIVE_PRIORITY:
+      sys_priority = 0;
+      break;
+    default:
+    case OBJC_THREAD_BACKGROUND_PRIORITY:
+      sys_priority = -1;
+      break;
+    case OBJC_THREAD_LOW_PRIORITY:
+      sys_priority = -127;
+      break;
+    }
+
+	SetTaskPri(FindTask(0), sys_priority);
+	
+	return 0;
 }
 
 /* Return the current thread's priority.  */
 int
 objc_thread_get_priority (void)
 {
-  return __gthread_objc_thread_get_priority ();
+	LONG priority = 0;
+	
+	NewGetTaskAttrsA(FindTask(0), &priority, sizeof (priority), TASKINFOTYPE_PRI, NULL);
+
+	if (priority < -10)
+		return OBJC_THREAD_LOW_PRIORITY;
+	
+	if (priority < 0)
+		return OBJC_THREAD_BACKGROUND_PRIORITY;
+	
+	return OBJC_THREAD_INTERACTIVE_PRIORITY;
 }
 
 /* Yield our process time to another thread.  Any BUSY waiting that is
@@ -202,7 +266,7 @@
 void
 objc_thread_yield (void)
 {
-  __gthread_objc_thread_yield ();
+//  __gthread_objc_thread_yield ();
 }
 
 /* Terminate the current thread.  Doesn't return.  Actually, if it
@@ -216,7 +280,9 @@
   objc_mutex_unlock (__objc_runtime_mutex);
 
   /* Call the backend to terminate the thread.  */
-  return __gthread_objc_thread_exit ();
+//  return __gthread_objc_thread_exit ();
+  Wait(0);
+  __builtin_trap();
 }
 
 /* Returns an integer value which uniquely describes a thread.  Must
@@ -224,7 +290,10 @@
 objc_thread_t
 objc_thread_id (void)
 {
-  return __gthread_objc_thread_id ();
+	ULONG pid = 0;
+	NewGetTaskAttrsA(FindTask(0), &pid, sizeof (pid), TASKINFOTYPE_PID, NULL);
+  	return (objc_thread_t)(size_t) pid;
+//  return __gthread_objc_thread_id ();
 }
 
 /* Sets the thread's local storage pointer.  Returns 0 if successful
@@ -232,7 +301,9 @@
 int
 objc_thread_set_data (void *value)
 {
-  return __gthread_objc_thread_set_data (value);
+	NewSetTaskAttrsA(FindTask(0), (APTR)value, sizeof (ULONG), TASKINFOTYPE_USERDATA, 0);
+	return 0;
+//  return __gthread_objc_thread_set_data (value);
 }
 
 /* Returns the thread's local storage pointer.  Returns NULL on
@@ -240,7 +311,10 @@
 void *
 objc_thread_get_data (void)
 {
-  return __gthread_objc_thread_get_data ();
+	ULONG rc = 0;
+	NewGetTaskAttrsA(FindTask(0), &rc, sizeof (ULONG), TASKINFOTYPE_USERDATA, 0);
+	return (void *)rc;
+//  return __gthread_objc_thread_get_data ();
 }
 
 /* Public mutex functions */
@@ -256,6 +330,19 @@
   if (! (mutex = (objc_mutex_t)objc_malloc (sizeof (struct objc_mutex))))
     return NULL;
 
+#ifdef __MORPHOS__
+	mutex->backend = AllocMem(sizeof (struct SignalSemaphore), MEMF_ANY | MEMF_CLEAR);
+	
+	if (NULL != mutex->backend)
+	{
+		InitSemaphore((struct SignalSemaphore *)mutex->backend);
+	}
+	else
+	{
+      objc_free (mutex);
+      return NULL;
+	}
+#else
   /* Call backend to create the mutex.  */
   if (__gthread_objc_mutex_allocate (mutex))
     {
@@ -263,6 +350,7 @@
       objc_free (mutex);
       return NULL;
     }
+#endif
 
   /* Initialize mutex.  */
   mutex->owner = NULL;
@@ -287,9 +375,13 @@
   /* Acquire lock on mutex.  */
   depth = objc_mutex_lock (mutex);
 
+#ifdef __MORPHOS__
+	FreeMem(mutex->backend, sizeof (struct SignalSemaphore));
+#else
   /* Call backend to destroy mutex.  */
   if (__gthread_objc_mutex_deallocate (mutex))
     return -1;
+#endif
 
   /* Free the mutex structure.  */
   objc_free (mutex);
@@ -313,12 +405,21 @@
     return -1;
 
   /* If we already own the lock then increment depth.  */
+#ifdef __MORPHOS__
+  thread_id = objc_thread_id ();
+#else
   thread_id = __gthread_objc_thread_id ();
+#endif
   if (mutex->owner == thread_id)
     return ++mutex->depth;
 
   /* Call the backend to lock the mutex.  */
+#ifdef __MORPHOS__
+	ObtainSemaphore(mutex->backend);
+	status = 0;
+#else
   status = __gthread_objc_mutex_lock (mutex);
+#endif
 
   /* Failed?  */
   if (status)
@@ -343,12 +444,21 @@
     return -1;
 
   /* If we already own the lock then increment depth.  */
+#ifdef __MORPHOS__
+  thread_id = objc_thread_id ();
+#else
   thread_id = __gthread_objc_thread_id ();
+#endif
   if (mutex->owner == thread_id)
     return ++mutex->depth;
     
   /* Call the backend to try to lock the mutex.  */
+#ifdef __MORPHOS__
+  if (AttemptSemaphore((struct SignalSemaphore *)mutex->backend))
+	status = 0;
+#else
   status = __gthread_objc_mutex_trylock (mutex);
+#endif
 
   /* Failed?  */
   if (status)
@@ -375,7 +485,11 @@
     return -1;
 
   /* If another thread owns the lock then abort.  */
+#ifdef __MORPHOS__
+  thread_id = objc_thread_id ();
+#else
   thread_id = __gthread_objc_thread_id ();
+#endif
   if (mutex->owner != thread_id)
     return -1;
 
@@ -388,7 +502,12 @@
   mutex->owner = NULL;
 
   /* Have the backend unlock the mutex.  */
+#ifdef __MORPHOS__
+  status = 0;
+  ReleaseSemaphore(mutex->backend);
+#else
   status = __gthread_objc_mutex_unlock (mutex);
+#endif
 
   /* Failed?  */
   if (status)
@@ -404,6 +523,9 @@
 objc_condition_t 
 objc_condition_allocate (void)
 {
+#ifdef __MORPHOS__
+  return 0;
+#else
   objc_condition_t condition;
     
   /* Allocate the condition mutex structure.  */
@@ -421,6 +543,7 @@
 
   /* Success!  */
   return condition;
+#endif
 }
 
 /* Deallocate a condition. Note that this includes an implicit
@@ -431,6 +554,10 @@
 int
 objc_condition_deallocate (objc_condition_t condition)
 {
+#ifdef __MORPHOS__
+  condition = condition;
+  return 0;
+#else
   /* Broadcast the condition.  */
   if (objc_condition_broadcast (condition))
     return -1;
@@ -443,6 +570,7 @@
   objc_free (condition);
 
   return 0;
+#endif
 }
 
 /* Wait on the condition unlocking the mutex until
@@ -455,6 +583,11 @@
 int
 objc_condition_wait (objc_condition_t condition, objc_mutex_t mutex)
 {
+#ifdef __MORPHOS__
+  condition = condition;
+  mutex = mutex;
+  return -1;
+#else
   objc_thread_t thread_id;
 
   /* Valid arguments?  */
@@ -482,6 +615,7 @@
   mutex->depth = 1;
 
   return 0;
+#endif
 }
 
 /* Wake up all threads waiting on this condition. It is recommended
@@ -491,11 +625,16 @@
 int
 objc_condition_broadcast (objc_condition_t condition)
 {
+#ifdef __MORPHOS__
+  condition = condition;
+  return -1;
+#else
   /* Valid condition mutex?  */
   if (! condition)
     return -1;
 
   return __gthread_objc_condition_broadcast (condition);
+#endif
 }
 
 /* Wake up one thread waiting on this condition. It is recommended
@@ -505,11 +644,16 @@
 int
 objc_condition_signal (objc_condition_t condition)
 {
+#ifdef __MORPHOS__
+  condition = condition;
+  return -1;
+#else
   /* Valid condition mutex?  */
   if (! condition)
     return -1;
 
   return __gthread_objc_condition_signal (condition);
+#endif
 }
 
 /* Make the objc thread system aware that a thread which is managed
diff -ruN gcc-15.1.0.orig/libstdc++-v3/acinclude.m4 gcc-15.1.0/libstdc++-v3/acinclude.m4
--- gcc-15.1.0.orig/libstdc++-v3/acinclude.m4	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/acinclude.m4	2025-04-25 15:58:40.288620027 +0300
@@ -775,9 +775,9 @@
     # is selected.  FIXME: these variables are misnamed, there are
     # no executables installed in _toolexecdir or _toolexeclibdir.
     if test x"$gxx_include_dir" = x"no"; then
-      gxx_include_dir='${libdir}/gcc/${host_alias}/${gcc_version}/include/c++'
+      gxx_include_dir='${libdir}/gcc-lib/${host_alias}/${gcc_version}/include/c++'
     fi
-    glibcxx_toolexecdir='${libdir}/gcc/${host_alias}'
+    glibcxx_toolexecdir='${libdir}/gcc-lib/${host_alias}'
     glibcxx_toolexeclibdir='${toolexecdir}/${gcc_version}$(MULTISUBDIR)'
   fi
 
@@ -796,7 +796,7 @@
 	  ;;
       esac
     else
-      glibcxx_toolexecdir='${libdir}/gcc/${host_alias}'
+      glibcxx_toolexecdir='${libdir}/gcc-lib/${host_alias}'
       glibcxx_toolexeclibdir='${libdir}'
     fi
     multi_os_directory=`$CXX -print-multi-os-directory`
@@ -2791,6 +2791,8 @@
   fi
   enable_clocale_flag=$enable_clocale
 
+
+
   # Probe for locale model to use if none specified.
   # Default to "generic".
   if test $enable_clocale_flag = auto; then
@@ -5069,13 +5071,7 @@
        #include <unistd.h>
       ],
       [
-       #if _XOPEN_VERSION < 500
-       #error
-       #elif _XOPEN_VERSION >= 700 || defined(PATH_MAX)
        char *tmp = realpath((const char*)NULL, (char*)NULL);
-       #else
-       #error
-       #endif
       ],
       [glibcxx_cv_realpath=yes],
       [glibcxx_cv_realpath=no])
diff -ruN gcc-15.1.0.orig/libstdc++-v3/config/io/basic_file_stdio.cc gcc-15.1.0/libstdc++-v3/config/io/basic_file_stdio.cc
--- gcc-15.1.0.orig/libstdc++-v3/config/io/basic_file_stdio.cc	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/config/io/basic_file_stdio.cc	2025-04-25 15:58:40.288620027 +0300
@@ -440,6 +440,7 @@
   __basic_file<char>::showmanyc()
   {
 #if !defined(_GLIBCXX_NO_IOCTL) && !defined(_GLIBCXX_USE_STDIO_PURE)
+#ifndef __libnix__
 #ifdef FIONREAD
     // Pipes and sockets.
     int __num = 0;
@@ -448,6 +449,7 @@
       return __num;
 #endif
 #endif
+#endif
 
 #if defined(_GLIBCXX_HAVE_POLL) && !defined(_GLIBCXX_USE_STDIO_PURE)
     // Cheap test.
diff -ruN gcc-15.1.0.orig/libstdc++-v3/config/os/generic/os_defines.h gcc-15.1.0/libstdc++-v3/config/os/generic/os_defines.h
--- gcc-15.1.0.orig/libstdc++-v3/config/os/generic/os_defines.h	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/config/os/generic/os_defines.h	2025-04-25 15:58:40.288620027 +0300
@@ -38,4 +38,10 @@
 // workaround in gthr-posix.h and at link-time for static linking.
 #define _GLIBCXX_GTHREAD_USE_WEAK 0
 
+#ifdef __MORPHOS__
+// Disable the libstdc++ weak reference logic completely for MorphOS because
+// it is broken.
+#define _GLIBCXX_USE_WEAK_REF 0
+#endif
+
 #endif
diff -ruN gcc-15.1.0.orig/libstdc++-v3/crossconfig.m4 gcc-15.1.0/libstdc++-v3/crossconfig.m4
--- gcc-15.1.0.orig/libstdc++-v3/crossconfig.m4	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/crossconfig.m4	2025-04-25 15:58:40.296620091 +0300
@@ -198,6 +198,12 @@
     AC_CHECK_FUNCS(_wfopen)
     GCC_CHECK_TLS
     ;;
+  *-morphos*)
+    GLIBCXX_CHECK_COMPILER_FEATURES
+    GLIBCXX_CHECK_LINKER_FEATURES
+    GLIBCXX_CHECK_MATH_SUPPORT
+    GLIBCXX_CHECK_STDLIB_SUPPORT
+    ;;
   *-netbsd* | *-openbsd*)
     SECTION_FLAGS='-ffunction-sections -fdata-sections'
     AC_SUBST(SECTION_FLAGS) 
diff -ruN gcc-15.1.0.orig/libstdc++-v3/include/bits/locale_classes.h gcc-15.1.0/libstdc++-v3/include/bits/locale_classes.h
--- gcc-15.1.0.orig/libstdc++-v3/include/bits/locale_classes.h	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/include/bits/locale_classes.h	2025-04-25 15:58:40.296620091 +0300
@@ -379,8 +379,12 @@
     _M_coalesce(const locale& __base, const locale& __add, category __cat);
 
 #if _GLIBCXX_USE_CXX11_ABI
+#ifdef __MORPHOS__
+static const id* _S_twinned_facets[];
+#else
     static const id* const _S_twinned_facets[];
 #endif
+#endif
   };
 
 #if __cpp_lib_type_trait_variable_templates // C++ >= 17
diff -ruN gcc-15.1.0.orig/libstdc++-v3/include/std/mutex gcc-15.1.0/libstdc++-v3/include/std/mutex
--- gcc-15.1.0.orig/libstdc++-v3/include/std/mutex	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/include/std/mutex	2025-04-25 15:58:40.296620091 +0300
@@ -915,7 +915,21 @@
       once_flag::_Prepare_execution __exec(__callable);
 
       // XXX pthread_once does not reset the flag if an exception is thrown.
-      if (int __e = __gthread_once(&__once._M_once, &__once_proxy))
+      int __e = 0;
+#if defined(__MORPHOS__) && defined(__EXCEPTIONS)
+      try
+      {
+#endif
+	__e = __gthread_once(&__once._M_once, &__once_proxy);
+#if defined(__MORPHOS__) && defined(__EXCEPTIONS)
+      }
+      catch (...)
+      {
+	__gthread_once_unlock(&__once._M_once);
+	throw;
+      }
+#endif
+      if (__e)
 	__throw_system_error(__e);
     }
 
